/*****************************************************************************/
/*                   Reflections Plugin Support Functions                    */
/*****************************************************************************/

/* title:    modal & non modal requester function protos */
/* author:   Reinhard Grams */
/* version:  1.0, 14.11.97 */
/* updated:  10.3.98 by RG */

/*****************************************************************************/

#ifndef NMREQ_F_INCLUDED
#define NMREQ_F_INCLUDED

/*****************************************************************************/

   void
UpdateNMRequester
   (long id,long nr_of_entries,long *codes,void **vars,void **tmp);

   long
GetNMRequesterAlteredVariable
   (long nr_of_entries,long *codes,void **vars,void **tmp);

   void
CancelNMRequester
   (long nr_of_entries,long *codes,void **vars,void **org);

#define CreateNMRequester(a,b,c,d,e,f,g,h,i,j,k)\
        CreateNMRequesterXY(a,b,-1,-1,c,d,e,f,g,h,i,j,k)

   long
CreateNMRequesterXY
   (char *title,long id,long x_pos,long y_pos,long nr_of_entries,long *messages,long *codes,
   void **vars,void **tmp, void **org,char **names,float *minmax,long modal);

/*****************************************************************************/

#endif

/*****************************************************************************/
