/*****************************************************************************/
/*                                amiga includes                             */
/*****************************************************************************/

/* title:    amiga header include */
/* author:   Reinhard Grams */
/* version:  1.0, 22.12.97 */
/* updated:  10.3.98 by RG */
/* updated:  2.3.2000 by RG */

/*****************************************************************************/

#ifdef AMIGA

#include <exec/exec.h>
#include <pragmas/exec_pragmas.h>
#include <clib/exec_protos.h>

/* dont edit the following! */

#ifdef m881
#include <m68881.h>
#endif

#ifdef mffp
#include <mffp.h>
#include <pragmas/mathtrans_pragmas.h>
#include <pragmas/mathffp_pragmas.h>
struct Library *MathTransBase=NULL;
struct Library *MathBase=NULL;
#endif

void *plugin_libbase=NULL;
long libs_installed=1;

/* the prefix is defined in the makefile */
#define RPI_message PLUG_RPI_message

/* refgatew.library entries */
#pragma libcall plugin_libbase RPI_host 1e 9802
#pragma libcall plugin_libbase RPI_do 24 9802

/* to avoid linker message when using sprintf in library */
void __stdargs _XCEXIT(long dummy) {}

#endif

/*****************************************************************************/
