// MonDll.cpp : Legt die Initialisierungsroutinen fr die DLL fest.
//

#include "stdafx.h"
#include "MonDll.h"
#include "globals.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//
//	Beachten Sie!
//
//		Wird diese DLL dynamisch an die MFC-DLLs gebunden,
//		muss bei allen von dieser DLL exportierten Funktionen,
//		die MFC-Aufrufe durchfhren, das Makro AFX_MANAGE_STATE
//		direkt am Beginn der Funktion eingefgt sein.
//
//		Beispiel:
//
//		extern "C" BOOL PASCAL EXPORT ExportedFunction()
//		{
//			AFX_MANAGE_STATE(AfxGetStaticModuleState());
//		// Hier normaler Funktionsrumpf
//		}
//
//		Es ist sehr wichtig, dass dieses Makro in jeder Funktion
//		vor allen MFC-Aufrufen erscheint. Dies bedeutet, dass es
//		als erste Anweisung innerhalb der Funktion ausgefhrt werden
//		muss, sogar vor jeglichen Deklarationen von Objektvariablen,
//		da ihre Konstruktoren Aufrufe in die MFC-DLL generieren
//		knnten.
//
//		Siehe MFC Technical Notes 33 und 58 fr weitere
//		Details.
//

/////////////////////////////////////////////////////////////////////////////
// CMonDllApp

BEGIN_MESSAGE_MAP(CMonDllApp, CWinApp)
	//{{AFX_MSG_MAP(CMonDllApp)
		// HINWEIS - Hier werden Mapping-Makros vom Klassen-Assistenten eingefgt und entfernt.
		//    Innerhalb dieser generierten Quelltextabschnitte NICHTS VERNDERN!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMonDllApp Konstruktion

CMonDllApp::CMonDllApp()
{
	// ZU ERLEDIGEN: Hier Code zur Konstruktion einfgen
	// Alle wichtigen Initialisierungen in InitInstance platzieren
}

/////////////////////////////////////////////////////////////////////////////
// Das einzige CMonDllApp-Objekt

CMonDllApp theApp;

/*****************************************************************************/
/* read the configuration file of the plugin */

   long
RefPlugReadConfig
   (void)
{
   long err=PLUG_OK;
   RPI_FILE file=NULL;
   char name[256];
   long item=0;
   char *data=(char *)&user_config.data;

   strcpy(name,info.ref_path); strcat(name,CONFIG_FILENAME);

   if (RPI_file_exist(HND,name)) {

      if (!(file=RPI_file_open_read_binary(HND,PLUG_FILE_MODE,name))) {
         err=PLUG_CONFIG_OPEN_ERR; goto ErrorExit;
      }
      if (!(RPI_file_read_binary(file,user_config.id,4))) {
         err=PLUG_READ_ERR; goto ErrorExit;
      }
      if (strcmp(user_config.id,PLUG_CONFIG_ID)) {
         err=PLUG_CONFIG_ERR; goto ErrorExit;
      }
      if (!(RPI_file_read_long(file,&user_config.version))) {
         err=PLUG_READ_ERR; goto ErrorExit;
      }
      if (user_config.version!=PLUG_CONFIG_VERSION) {
         err=PLUG_CONFIG_ERR; goto ErrorExit;
      }
      if (!(RPI_file_read_long(file,&user_config.menu_x))) {
         err=PLUG_READ_ERR; goto ErrorExit;
      }
      if (!(RPI_file_read_long(file,&user_config.menu_y))) {
         err=PLUG_READ_ERR; goto ErrorExit;
      }
      while (item<PLUG_DATA_ENTRIES) {

         if (!(data_read.functions[descriptors[item].type])(file,data,descriptors[item].count)) {
            err=PLUG_READ_ERR; goto ErrorExit;
         }
         data=&data[descriptors[item].count*data_size[descriptors[item].type]];
         item++;
      }
      config=&user_config; /* all values readed, config is valid */
   }
   
ErrorExit:
   if (file) RPI_file_close(file);
   return(err);
}

/*****************************************************************************/
/* write the configuration file of the plugin */

   long
RefPlugWriteConfig
   (void)
{
   long err=PLUG_OK;
   RPI_FILE file=NULL;
   char name[256];
   long item=0;
   char *data=(char *)&config->data;

   strcpy(name,info.ref_path); strcat(name,CONFIG_FILENAME);

   if (!(file=RPI_file_open_write_binary(HND,PLUG_FILE_MODE,name))) {
      err=PLUG_CONFIG_OPEN_ERR; goto ErrorExit;
   }
   if (!(RPI_file_write_binary(file,config->id,4))) {
      err=PLUG_WRITE_ERR; goto ErrorExit;
   }
   if (!(RPI_file_write_long(file,config->version))) {
      err=PLUG_WRITE_ERR; goto ErrorExit;
   }
   if (!(RPI_file_write_long(file,config->menu_x))) {
      err=PLUG_WRITE_ERR; goto ErrorExit;
   }
   if (!(RPI_file_write_long(file,config->menu_y))) {
      err=PLUG_WRITE_ERR; goto ErrorExit;
   }
   while (item<PLUG_DATA_ENTRIES) {

      if (!(data_write.functions[descriptors[item].type])(file,data,descriptors[item].count)) {
         err=PLUG_WRITE_ERR; goto ErrorExit;
      }
      data=&data[descriptors[item].count*data_size[descriptors[item].type]];
      item++;
   }

ErrorExit:
   if (file) RPI_file_close(file);
   return(err);
}

/*****************************************************************************/
/* get the error message of error code */

   void
GetErrorMessage
   (long err,char *buffer)
{
   if (err>0 && err<ERROR_MESSAGES) 
      sprintf(buffer,"%s: %s",PLUG_NAME,mess_text[err]);
   else 
      sprintf(buffer,"%s: %s %ld",PLUG_NAME,mess_text[PLUG_INTERNAL_ERR],err);
}

/*****************************************************************************/
/* this function is called at first when PLI_CONNECT arrives */

   long 
RefPlugConnectInit
   (void)
{
   long err=PLUG_OK;
   char mess[128];

   #ifdef PLUGIN_STUBS_LIBRARY   
   unsigned long dll_version;
   dll_version=MonPlugsGetVersion();
   if (dll_version<DLL_VERSION) {
      err=PLUG_DLL_VERSION_ERR; goto ErrorExit;
   }
   #endif

   /* request pathes, screen, version and language values */
   if (!RPI_get_ref_char_info(HND,REF_DIR,info.ref_path)) {
      err=PLUG_REF_DIR_ERR; goto ErrorExit;
   }
   if (!RPI_get_ref_char_info(HND,REF_TEMP_DIR,info.ref_temp)) {
      err=PLUG_REF_DIR_ERR; goto ErrorExit;
   }
   if (!RPI_get_ref_info(HND,DISP_DX,&info.scr_width)) {
      err=PLUG_GET_VALUE_ERR; goto ErrorExit;
   }
   if (!RPI_get_ref_info(HND,DISP_DY,&info.scr_height)) {
      err=PLUG_GET_VALUE_ERR; goto ErrorExit;
   }
   if (!RPI_get_ref_info(HND,DISP_DEPTH,&info.scr_depth)) {
      err=PLUG_GET_VALUE_ERR; goto ErrorExit;
   }
   if (!RPI_get_ref_info(HND,VERSION,&info.ref_version)) {
      err=PLUG_GET_VALUE_ERR; goto ErrorExit;
   }
   if (!RPI_get_ref_info(HND,RELEASE,&info.ref_release)) {
      err=PLUG_GET_VALUE_ERR; goto ErrorExit;
   }
   if (!RPI_get_ref_info(HND,REVISION,&info.ref_revision)) {
      err=PLUG_GET_VALUE_ERR; goto ErrorExit;
   }
   if (!RPI_get_ref_info(HND,LANGUAGE,&info.ref_language)) {
      err=PLUG_GET_VALUE_ERR; goto ErrorExit;
   }
   if (err=RefPlugReadConfig()) {
      goto ErrorExit;
   }
   sprintf(mess,PLUG_INSTALL_MESSAGE,PLUG_NAME,PLUG_VERSION,PLUG_REVISION,
      info.ref_version,info.ref_release,info.ref_revision);
   RPI_print(HND,mess);

ErrorExit:
   return(err);
}

/*****************************************************************************/
/* this function is called at last when PLI_CONNECT arrives */

   long 
RefPlugConnect
   (void)
{
   long err=PLUG_OK;

   /* place your setup code here */

   return(err);
}

/*****************************************************************************/
/* this function is called when PLI_CLOSE_RESOURCES arrives */

   long
RefPlugCloseResources
   (void)
{
   long err=PLUG_OK;
   char mess[128];

   /* place your cleanup code here */

   sprintf(mess,PLUG_REMOVE_MESSAGE,PLUG_NAME,PLUG_VERSION,PLUG_REVISION);
   RPI_print(HND,mess);
   err=RefPlugWriteConfig();

   return(err);
}

/*****************************************************************************/
/* used to delete our own object (the create_object) */

   void
RefPlugRemoveToolObject
   (void)
{
   long lock;

   if (create_object) {
      ignore_delete=1;
      RPI_obj_unlock(HND,create_object,&lock);
      RPI_obj_free(HND,create_object);
      create_object=NULL;
      ignore_delete=0;
   }
}

/*****************************************************************************/
/* the user has edited an element of the requester */

   long
HandleNMRequester
   (long tool_id)
{
   long err=PLUG_OK;
   long changed;

   changed=GetNMRequesterAlteredVariable(REQ1_ITEMS,req1_codes,req1_vars,req1_tmp_vars);

   /* check if requester is still under construction */
   if (!req1_messages) goto ErrorExit;
 
   /* if a value has been edited */
   if (changed>=0) {

      switch (changed) {
         case 0:
            RPI_print(HND,"String edited");
         break;
         case 1:
            RPI_print(HND,"Int 1 edited");
         break;
         case 2:
            RPI_print(HND,"Int 2 edited");
         break;
         case 4:
            RPI_print(HND,"Float 1 edited");
         break;
         case 5:
            RPI_print(HND,"Float 2 edited");
         break;
         case 6:
            RPI_print(HND,"Cycle edited");
         break;
      }
   }

ErrorExit:
   return(err);
}

/*****************************************************************************/

   long
HandleCancelNMRequester
   (long tool_id)
{
   long err=PLUG_OK;

   /* user has canceled requester, restore original values */
   CancelNMRequester(REQ1_ITEMS,req1_codes,req1_vars,req1_org_vars);
   /* if object has been created, remove it */
   if (create_object) {
      RefPlugRemoveToolObject();
      RPI_plot_pkl(HND);
   }
   tool_requester=0;
   return(err);
}

/*****************************************************************************/

   long
HandleExitNMRequester
   (long tool_id)
{
   long err=PLUG_OK;
   long lock;

   /* user has closed requester, perform cleanup if neccessary */
   if (create_object) {
      RPI_obj_unlock(HND,create_object,&lock);
      create_object=NULL;
   }
   tool_requester=0;
   return(err);
}

/*****************************************************************************/
/* this is the beef! this function gets called when the user selected */
/* one of our created menu entries */

   long
DoCreateTool
   (long tool_id)
{
   long err=PLUG_OK;
   PlugData *data=&config->data;

   /* set the pointers to the requester variables */
   req1_vars[0]=data->string;     /* first element is a string */
   req1_vars[1]=&data->longs[0];  /* first integer */
   req1_vars[2]=&data->longs[1];  /* second integer */
   req1_vars[3]=NULL; /* null for text elements */
   req1_vars[4]=&data->floats[0]; /* first float */
   req1_vars[5]=&data->floats[1]; /* second float */
   req1_vars[6]=&req1_cycle; /* cycle structure */
   req1_cycle.select=&data->cycle; /* ptr in structure */

   create_object=NULL; /* just to avoid panic */
   tool_requester=0;

   if (err=CreateNMRequester(HND, REQ1_TITLE,TOOL_ID1,REQ1_ITEMS,
         &req1_messages,req1_codes,req1_vars,req1_tmp_vars,req1_org_vars,
         req1_names,req1_minmax,INTERACTIVE_REQUESTER)) {
      goto ErrorExit;
   }
   MakeRequesterBetterLook();
   tool_requester=1;

ErrorExit:
   return(err);
}

/*****************************************************************************/
/* this is the one and only entry of our plugin for reflections */
/* you may add case switches to process other messages */

   long REFPROG
RPI_message
   (PTR0 PLI_param *in,PTR1 PLI_param *out)
{
   AFX_MANAGE_STATE(AfxGetStaticModuleState());

   long err=PLUG_OK;
   char mess[128];
   long lock,tool;

   /* obsolete in further versions */
   out->l_param[0]=TOOL_OK;

   #ifdef AMIGA
   if (!libs_installed) return(RPI_MESSAGE_UNKNOWN);
   #endif

   switch(in->id) {

      case FPLUG_INIT_MESSAGE: 
         /* only initialize our plugin, we get connected later */         
         HND=in->v_param[0]; /* get global plug handle for further use */
      break;

      case PLI_CONNECT:
          /* open amiga libraries */
         #include <AmiOpen.c>
         /* call plugin init function */
         if (err=RefPlugConnectInit()) {
            goto ErrorExit;
         }
         /* the basic things are set up, now tell reflections */
         /* what kind of messages we are waiting for */
         for (tool=NR_OF_CREATE_ENTRIES-1;tool>=0;tool--) {
            if (!RPI_add_create_tool(HND,tool_names[tool],TOOL_ID1+tool)) {
               err=PLUG_INSTALL_EVENT_ERR; goto ErrorExit;
            }
         }
         tool_installed=1;
         /* call plugin connect function */
         if (err=RefPlugConnect()) {
            goto ErrorExit;
         }
      break;

      case PLI_TOUCH:
         /* user has selected the plugin menu entry a second time */
         RPI_free_myself(HND);
      break;

      case PLI_CLOSE_RESOURCES:
         /* reflections is going to remove us, call shutdown function */
         if (tool_installed) {
            for (tool=NR_OF_CREATE_ENTRIES-1;tool>=0;tool--) {
               RPI_sub_create_tool(HND,TOOL_ID1+tool);
            }
            tool_installed=0;
         }
         if (create_object) {
            RPI_obj_unlock(HND,create_object,&lock);
            create_object=NULL;
         }
 			if (tool_requester) {
            RPI_close_nonmodal_requester(HND,TOOL_ID1);
      		tool_requester=0;
	      }
         /* call plugin exit function */
         err=RefPlugCloseResources();
      break;

      case FPLUG_CLOSE_MESSAGE:
         /* we are going to be removed from memory, the shop is closed! */
         HND=NULL;
         /* close the amiga libraries */
         #include <AmiClose.c>
      break;

      case PLI_DO_CREATE_TOOL:
         /* now its time to create whatever has to be created */
         if (create_object || tool_requester) {
            err=PLUG_WORKING_ERR; goto ExitMessageHandler;
         }
         if (!RPI_obj_inform(HND,INFORM_OBJ_DEL)) {
            err=PLUG_INSTALL_EVENT_ERR; goto ErrorExit;
         }
         if (err=DoCreateTool(in->l_param[0])) {
            goto ExitMessageHandler;
         }
      break;

      case PLI_NM_REQUESTER_CHANGED:
         /* user has edited a requester entry */
         if (err=HandleNMRequester(in->l_param[0])) {
            goto ErrorExit;
         }
      break;

      case PLI_NM_REQUESTER_CANCEL:
         /* user has canceled requester */
         if (err=HandleCancelNMRequester(in->l_param[0])) {
            goto ErrorExit;
         }
      break;

      case PLI_NM_REQUESTER_OK:
         /* user has closed the requester */
         if (err=HandleExitNMRequester(in->l_param[0])) {
            goto ErrorExit;
         }
      break;

      case PLI_OBJ_EVENT:
         /* check if our object has been deleted */
         if (!ignore_delete && in->l_param[0]==INFORM_OBJ_DEL && in->v_param[0]==create_object) {
   			if (tool_requester) {
               RPI_close_nonmodal_requester(HND,TOOL_ID1);
		   		tool_requester=0;
			   }
            create_object=NULL;
         }
      break;

      default:/* other messages */
         return(RPI_MESSAGE_UNKNOWN);
      break;
   }

ExitMessageHandler: /* display error message (if any) and return ok */
   /* jump to this label if your job is done and you want the plugin */
   /* to return the control to reflections. set the appropriate err code */
   /* to get an error message displayed, otherwise set err to PLUG_OK. */
   if (err) {
      GetErrorMessage(err,mess);
      RPI_message_win(HND,mess);
   }
   return(RPI_MESSAGE_PROCESSED);

ErrorExit: /* display error message and die */
   /* jump to this label if the plugin cannot intialize or a severe error */
   /* has occured and the plugin has to be unloaded. set the appropriate */
   /* err code to get an error message displayed, PLUG_OK is not allowed. */
   GetErrorMessage(err,mess);
   RPI_message_win(HND,mess);   
   RPI_free_myself(HND);
   return(RPI_MESSAGE_ERROR);
}

/*****************************************************************************/
