/*****************************************************************************/
/*                   Reflections Plugin Support Functions                    */
/*****************************************************************************/

/* title:    modal & non modal requester function protos, handle as parm */
/* author:   Reinhard Grams */
/* version:  1.0, 14.11.97 */
/* updated:  10.3.98 by RG */
/*
   (c) 1998 und Vertrieb Oberland Computer
   In der Schneithohl 5
   61476 Kronberg
   Deutschland
   Tel.: 06173-608-0
   Fax:  06173-63385

   Support-Telefon: 06173-608-190
   Support-Fax:     06173-608-250
   Internet, WWW:   http://www.oberland.com
*/
/*****************************************************************************/

#ifndef NMREQ_F_INCLUDED
#define NMREQ_F_INCLUDED

/*****************************************************************************/

   void
UpdateNMRequester
   (RPI_HANDLE handle,long id,long nr_of_entries,long *codes,void **vars,void **tmp);

   long
GetNMRequesterAlteredVariable
   (long nr_of_entries,long *codes,void **vars,void **tmp);

   void
CancelNMRequester
   (long nr_of_entries,long *codes,void **vars,void **org);

   long
CreateNMRequester
   (RPI_HANDLE handle,char *title,long id,long nr_of_entries,long *messages,long *codes,
   void **vars,void **tmp, void **org,char **names,float *minmax,long modal);

/*****************************************************************************/

#endif

/*****************************************************************************/
