/*****************************************************************************/
/*          refgateway stub functions for proper and save usage              */
/*                  of the RPI_do(in,out) commands.                          */
/*****************************************************************************/
/* title:    camera functions */
/* author:   Carsten Fuchs  */
/* version:  1.0, 23.2.2000   */
/* updated:  2.3.2000 by RG */
/*****************************************************************************/
#if MONZOOM_VERSION >= 45
/*****************************************************************************/
/* set the actual camera */

   RPIStub long
RPI_set_akt_kam
   (RPI_HANDLE handle,RPI_OBJECT kam);

   /* handle:      refgateway-handle
      kam:         ptr to camera-object
      returns:     0 if failed
                   1 if ok
   */
/*****************************************************************************/
/* get the actual camera */

   RPIStub long
RPI_get_akt_kam
   (RPI_HANDLE handle,RPI_OBJECT *kam);

   /* handle:      refgateway-handle
      kam:         destination for camera-object
      returns:     0 if failed
                   1 if ok
   */
/*****************************************************************************/
#endif
/*****************************************************************************/
