/*****************************************************************************/
/*                    definitions for reflections gateway                    */
/*                 interface functions for external plugins                  */
/*****************************************************************************/

/* title:    refgateway interface definitions */
/* author:   Carsten Fuchs */
/* version:  1.0, 16.9.97 */
/* updated:  23.3.98 by RG */
/* updated:  16.11.99 by RG */
/* updated:  2.12.99 by RG */
/* updated:  14.1.2000 by RG */
/* updated:  2.3.2000 by RG */

/*****************************************************************************/

#ifndef REFGATEW_H
#define REFGATEW_H

/*****************************************************************************/

#include <fplug.h>

/*****************************************************************************/

#ifndef DLL_EXPORT
#define DLL_EXPORT
#endif
#ifndef DLL_IMPORT
#define DLL_IMPORT
#endif

/*****************************************************************************/

/* RPI_message() is the one and only entry to each plugin */
DLL_EXPORT long REFPROG RPI_message(PTR0 PLI_param *in,PTR1 PLI_param *out);

/* RPI_do is the one and only entry to reflections for a plugin */
DLL_IMPORT long REFPROG RPI_do(PTR0 PLI_param *in,PTR1 PLI_param *out);

/*****************************************************************************/

#endif

/*****************************************************************************/
