#include "stdafx.h"
#include "globals.h"

//#include <nmreq.c>
extern "C" {
#include <nmreq2.c>
#include <Rgw_stub.c>
}

void *HND=NULL;

_info_ info = { "","",0,0,0,0,0,0,0 };

void *req1_org_vars[REQ1_ENTRIES] = {
   
   &req1_org_strings[0],
   &req1_org_ints[0],
   &req1_org_ints[1],
   NULL, /* null for text elements */
   &req1_org_floats[0],
   &req1_org_floats[1],
   &req1_org_cycles[0],
};

void *req1_tmp_vars[REQ1_ENTRIES] = {
   
   &req1_tmp_strings[0],
   &req1_tmp_ints[0],
   &req1_tmp_ints[1],
   NULL, /* null for text elements */
   &req1_tmp_floats[0],
   &req1_tmp_floats[1],
   &req1_tmp_cycles[0],
};

float req1_minmax[REQ1_EXTENDED*2] = {
   0.0F,5.0F,
   0.0F,10.0F,
};

long req1_codes[REQ1_ITEMS] = {

   CODE_STRING,
   CODE_LINE,
   CODE_INT,
   CODE_INT_EXTENDED,
   CODE_TEXT,
   CODE_REAL,
   CODE_REAL_EXTENDED,
   CODE_LINE,
   CODE_CYCLE,3, /* three cycle elements */
   CODE_LINE,
};

char *req1_names[REQ1_ENTRIES] = {

   "String",
   "Int 1",
   "Int 2",
   "Floats",
   "Float 1",
   "Float 2",
   "Switch",
};

Cycle req1_cycle=
{
  NULL,
  "Heinz","Hugo","Hubert",
};

char *tool_names[NR_OF_CREATE_ENTRIES]= {
   "CreaSkel1",
   "CreaSkel2",
};

Config user_config, default_config = {

   PLUG_CONFIG_ID,PLUG_CONFIG_VERSION,16,24,
   {
      "Willi",
      1.0F,2.0F,
      1,2,
      1,2,
      0,
      /* replace with your config defaults */
   },
};
Config *config=&default_config;

DataDesc descriptors[PLUG_DATA_ENTRIES] = {

   DATA_STRING,32,
   DATA_FLOAT,2,
   DATA_LONG,2,
   DATA_SHORT,2,
   DATA_LONG,1
   /* replace with your own config vars descriptors */
};

char  *mess_text[ERROR_MESSAGES]=
{
   "Interner Fehler",
   "Kein Speicher mehr frei",
   "Kann File nicht ffnen",
   "Kann Datei nicht lesen",
   "Kann Datei nicht schreiben",
   "Fehler beim Dateizugriff",
   "Fehlerhafte Konfigurationsdatei",
   "Kann Konfigurationsdatei nicht ffnen",
   "Kann Requester nicht ffnen",
   "Kann Werte nicht abfragen",
   "Kann Verzeichnis nicht ermitteln",
   "Bentige aktuelle MonPlugs.dll",
   "Kann Event nicht setzen",
   "Plugin ist bereits aktiv",
   /* add your error message here */
};

long tool_installed = 0;
long tool_requester = 0;
long ignore_delete = 0;
RPI_OBJECT create_object = NULL;

char req1_org_strings[REQ1_STRINGS][REQ1_STRING_BUFFER_SIZE];
long req1_org_ints[REQ1_INTS];
float req1_org_floats[REQ1_FLOATS];
long req1_org_cycles[REQ1_CYCLES];

char req1_tmp_strings[REQ1_STRINGS][REQ1_STRING_BUFFER_SIZE];
long req1_tmp_ints[REQ1_INTS];
float req1_tmp_floats[REQ1_FLOATS];
long req1_tmp_cycles[REQ1_CYCLES];

void *req1_vars[REQ1_ENTRIES];
long req1_messages;

extern "C"
{
  typedef long (*DataReadType)(RPI_FILE,void *,long);
DataIO data_read = {
   
   (DataReadType)RPI_file_read_binary,
   (DataReadType)RPI_file_read_floats,
   (DataReadType)RPI_file_read_longs,
   (DataReadType)RPI_file_read_shorts,
};

  typedef long (*DataWriteType)(RPI_FILE,void *,long);
DataIO data_write = {
   
   (DataWriteType)RPI_file_write_binary,
   (DataWriteType)RPI_file_write_floats,
   (DataWriteType)RPI_file_write_longs,
   (DataWriteType)RPI_file_write_shorts,
};
}